#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

double rescale(double z)
{
  if (z <= 0) throw string("rescale: arg not positive");
  while (z >= 10) z /= 10;
  while (z < 1) z *= 10;
  return z;
}

int first_digit(double z)
{
  return floor(rescale(z));
}

int second_digit(double z)
{
  z = rescale(z);
  z = z - floor(z);
  return floor(10*z);
}


int main()
{
  cout << "Program to count freq of first digit of powers of a number." << endl;
  cout << "Input positive number (not nec integer): ";
  double z;
  cin >> z;
  z = rescale(z);
  vector<int> freq1(10);
  vector<int> freq2(10);
  double power = 1;
  for (int i=0; i <= 1000; ++i)
  {
    ++freq1[first_digit(power)];
    ++freq2[second_digit(power)];
    power = rescale(power*z);
  }

  cout << "Freq table of the first digits of powers of " << z << endl;
  for (int i=1; i <= 9; ++i)
  {
    cout << "First digit " << i << "  occurred with freq " << freq1[i] << endl;
  }

  cout << "Freq table of the second digits of powers of " << z << endl;
  for (int i=0; i <= 9; ++i)
  {
    cout << "Second digit " << i << "  occurred with freq " << freq2[i] << endl;
  }
}



