#ifndef TOKENS_INCLUDED
#define TOKENS_INCLUDED
#include "../MyLib"

/*
    token ::= symb | num | var
    symb  ::= + | - | * | / | ( | ) | ; | q | =
    num   ::= <double>
    var   ::= x<nat>
*/

class Token {
    char kind; //symb, 0 for num, x for var
    int i;      //valid and >=0 only when kind='x'
    double d;   //valid only when kind='0'
    public:
    Token(): kind(';') {}
    Token(char s):  kind(s) {}
    Token(int x):   kind('x') {i=x;}
    Token(double x):kind('0') {d=x;}
    const char sym ()   { return kind; }
    const double num () { if (kind!='0') runtime_error("token non e' un numero"); return d; }
    const int var ()    { if (kind!='x') runtime_error("token non e' una variabile"); return i; }
};

ostream& operator << (ostream& o, Token& t)
    {
        char c=t.sym();
        if (c=='0') o << t.num();
        else if (c=='x') o << c << t.var();
        else o << c;
        o << ' ';
        return o;
    }
class Token_stream {
    bool full;
    Token buffer;
    public:
    Token_stream(): full(false), buffer('q') {}
    Token get()
    {
        if (full) { full=false; return buffer; };
        char c;
        cin >> c;
        if (!cin) throw runtime_error("bad token");
        switch (c)
        {
            case '0':
                double d;
                cin >> d;
                if (!cin) break;
                return Token(d);
            case 'x':
                int i;
                cin >> i;
                if (!cin) break;
                return Token(i);
            default:
                //aggiungere controlli su c
                return Token(c);
        }
    throw runtime_error("bad token");
    }

    void putback (const Token& t)
    {
        if (full) throw runtime_error("Token_stream putback error") ;
        full=true;
        buffer=t;
    }
};

#endif // TOKENS_INCLUDED
