#ifndef IO_HELPER_FUNCTIONS_H_INCLUDED
#define IO_HELPER_FUNCTIONS_H_INCLUDED

void skip_input_line ()
//ignora il resto della linea
//si ussume che una linea non contenga piu' di 256 caratteri
{
    cin.clear();
    cin.ignore(256,'\n');
}

void leggi_int (int &n)
{
    cout << "scrivi un intero> ";
    cin >> n;
    //solleva una eccezione in caso di errore
    if (!cin) throw runtime_error("non e' un intero");
    skip_input_line();
}

void leggi_string (string &s)
//la lettura si ferma al primo whitespace
{
    cout << "scrivi una stringa> ";
    cin >> s;
    //solleva una eccezione in caso di errore
    if (!cin) throw runtime_error("non e' una stringa");
    skip_input_line();
}


void leggi_int_seq ()
{
    int n;
    leggi_int(n);
    if (n<0) throw runtime_error("negative integer");
    vector<int> s(n); //array di n interi
    cout << "scrivi una sequenza di " << n << " interi\n> ";
    for (int i=0; i<n; i++)
    {
        cin >> s[i];
        //solleva una eccezione in caso di errore
        if (!cin) throw runtime_error("non e' una sequenza di <n> interi");
    }
    skip_input_line();
    for (int i=0; i<n; i++)
        cout << s[i] << " ";
    cout << "fine sequenza\n";
}

void scrivi_int_seq_su_file ()
{
    ofstream f;
    //begin apertura file
    cout << "nome del file ";
    string name;
    leggi_string(name);
    //controllare se name e' accettabile per il file system
    f.open(name.c_str());
    if (!f) throw runtime_error("file open non riuscita");
    //end apertura file
    cout << "scrivi una sequenza di interi (seguita da !)\n> ";
    int x;
    while (cin>>x)
    {
        f << x << '\t';
    }
    skip_input_line();
    f.close();
    cout << "file salvato!\n";
}

void leggi_int_seq_da_file ()
{
    ifstream f;
    cout << "nome del file ";
    string name;
    leggi_string(name);
    f.open(name.c_str());
    if (!f) throw runtime_error("file open non riuscita");
    cout << "la sequenza di interi contenuta nel file e':\n";
    int x;
    while (f>>x)
    {
        cout << x << '\t';
    }
    if (f.eof()) cout << "\nlettura del file completata!\n";
    else cout << "\nil resto del file contiene rumenta!\n";
    f.close();
}

#endif // IO_HELPER_FUNCTIONS_H_INCLUDED
